// -*- C++ -*-
// Copyright (C) 2000 Red Hat, Inc.
#ifndef _INTI_GDK_COLORMAP_H_
#define _INTI_GDK_COLORMAP_H_

/*
  Inti is a C++ development platform based on glib, GTK+, and the
  Standard Template Library. This header file is machine-generated
  by a script; do not edit it directly.

  This file is distributed under the GNU Library General Public License.
*/
/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <gdk/gdkcolor.h>
#include <inti/object.h>

namespace Inti
{  
  namespace Gdk
  {
    namespace Private
    {
      class ColormapClass;
    }; // namespace Private

    class Visual;
    class Color;
    
    class Colormap : public Object
    {
    public:
      GdkColormap * gdk_colormap () const { return (GdkColormap*)g_object (); }

      Colormap (const Visual & visual);
      
      static Colormap * system ();

      bool alloc_color (Color * color,
                        bool best_match = true);

      void free_color (const Color & color);

      const Visual & visual ();
      
    protected:
      friend class Private::ColormapClass;
      virtual ~Colormap ();
      Colormap (GdkColormap * src, GdkColormapClass * orig);

    private:
      Colormap (const Colormap&);
      Colormap& operator=(const Colormap&);

    }; // class Colormap
    
  }; // namespace Gdk
  
}; // namespace Inti

#endif // _INTI_GDK_COLORMAP_H_
