// -*- C++ -*-
// Copyright (C) 2000 Red Hat, Inc.
#ifndef _INTI_GTK_BIN_H_
#define _INTI_GTK_BIN_H_

/*
  Inti is a C++ development platform based on glib, GTK+, and the
  Standard Template Library. This header file is machine-generated
  by a script; do not edit it directly.

  This file is distributed under the GNU Library General Public License.
*/
/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <inti/gtk/container.h>
#include <gtk/gtkbin.h>

/*$ doc header
  $short The #Inti::Gtk::Bin abstract base class
  $*/

namespace Inti
{  
  namespace Gtk
  {
    namespace Private
    {
      class BinClass;
    };
    
    class Bin : public Container
    {
    public:
      /*$ doc class Bin
        $short abstract base class for containers that contain a single child

        $copy none
        $memory floating
        
        $long

        <para>

        </para>

        <para>

        </para>
        
        $*/
        
      GtkBin * gtk_bin () const
      {
        return (GtkBin*)g_object ();
      }
      
      /*$ doc constructor
        $short Construct a new Bin
        $long

        <para>

        </para>
        
        $*/
      Bin ();

      Widget * child () const;
      
    protected:
      friend class Private::BinClass;
      
      explicit Bin (GtkBin *src, GtkBinClass * orig);
      virtual ~Bin () = 0; // abstract base class
      
    private:
      Bin(const Bin&);
      Bin& operator=(const Bin&);
      
    }; // class Bin

  }; // namespace Gtk
  
}; // namespace Inti

#endif // _INTI_GTK_BIN_H_
