// -*- C++ -*-
// Copyright (C) 2000 Red Hat, Inc.
#ifndef _INTI_GTK_CHECKMENUITEM_H_
#define _INTI_GTK_CHECKMENUITEM_H_

/*
  Inti is a C++ development platform based on glib, GTK+, and the
  Standard Template Library. This header file is machine-generated
  by a script; do not edit it directly.

  This file is distributed under the GNU Library General Public License.
*/
/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <inti/gtk/menuitem.h>
#include <inti/gtk/gtkbase.h>
#include <gtk/gtkcheckmenuitem.h>

namespace Inti
{
  namespace Gtk
  {
    namespace Private
    {
      class CheckMenuItemClass;
    };

    class CheckMenuItem : public MenuItem
    {
    public:

      GtkCheckMenuItem * gtk_check_menu_item () const
      {
        return (GtkCheckMenuItem*)g_object ();
      }

      CheckMenuItem ();
      CheckMenuItem (const ustring & text);
      CheckMenuItem (const char * text);

      void set_active (bool is_active);
      bool active () const { return gtk_check_menu_item ()->active; }

    protected:
      typedef WrapSignal0<void> ToggledSignalType;
      static const ToggledSignalType toggled_signal;

    public:
      typedef SignalProxy<Object,ToggledSignalType> ToggledProxyType;
      const ToggledProxyType sig_toggled ()
      {
        return ToggledProxyType (this, &toggled_signal);
      }

    protected:
      friend class Private::CheckMenuItemClass;

      explicit CheckMenuItem (GtkCheckMenuItem *src, GtkCheckMenuItemClass *orig);
      virtual ~CheckMenuItem ();

      virtual void toggled_impl ();
      virtual void on_toggled ();

    private:
      CheckMenuItem(const CheckMenuItem&);
      CheckMenuItem& operator=(const CheckMenuItem&);

      static void toggled_proxy (GtkCheckMenuItem * w);

    }; // class CheckMenuItem

  }; // namespace Gtk

}; // namespace Inti

#endif // _INTI_GTK_CHECKMENUITEM_H_
