// -*- C++ -*-
// Copyright (C) 2000 Red Hat, Inc.
#ifndef _INTI_GTK_DND_H_
#define _INTI_GTK_DND_H_

/*
  Inti is a C++ development platform based on glib, GTK+, and the
  Standard Template Library. This header file is machine-generated
  by a script; do not edit it directly.

  This file is distributed under the GNU Library General Public License.
*/
/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <gtk/gtkdnd.h>
#include <inti/gdk/dnd.h>
#include <inti/gtk/widget.h>

namespace Inti
{
  namespace Gdk
  {
    class Bitmap;
    class Pixmap;
    class Colormap;
  }; // namespace Gdk
  
  namespace Gtk
  {
    class Window;
    
    class DragContext : public Gdk::DragContext
    {
    public:
      void finish (bool successful,
                   bool should_delete,
                   guint32 time);
      
      Widget * source_widget () const;

      void set_icon (Window * widget,
                     int hotspot_x,
                     int hotspot_y);

      void set_icon (Gdk::Colormap * colormap,
                     Gdk::Pixmap * pixmap,
                     Gdk::Bitmap * bitmap,
                     int hotspot_x,
                     int hotspot_y);

      void set_icon_default ();

      static Object * _private_get_wrapper (GObject * object);
      
    protected:
      virtual ~DragContext ();
      DragContext (GdkDragContext * src, GdkDragContextClass * orig);
      
    };

    
    
  }; // namespace Gtk
  
}; // namespace Inti

#endif // _INTI_GTK_DND_H_
