// -*- C++ -*-
// Copyright (C) 2000 Red Hat, Inc.
#ifndef _INTI_GTK_MENUSHELL_H_
#define _INTI_GTK_MENUSHELL_H_

/*
  Inti is a C++ development platform based on glib, GTK+, and the
  Standard Template Library. This header file is machine-generated
  by a script; do not edit it directly.

  This file is distributed under the GNU Library General Public License.
*/
/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <inti/gtk/container.h>
#include <inti/gtk/gtkbase.h>
#include <gtk/gtkmenushell.h>

/*$ doc header
  $short FIXME
  $*/

namespace Inti
{  
  namespace Gtk
  {
    namespace Private
    {
      class MenuShellClass;
    };

    class MenuItem;
    
    class MenuShell : public Container
    {
    public:
      /*$ doc class MenuShell
        $short FIXME

        $copy none
        $memory floating
        
        $long

        <para>

        </para>
        
        $*/
        
      GtkMenuShell * gtk_menu_shell () const
      {
        return (GtkMenuShell*)g_object ();
      }

      void append (MenuItem * item);
      void prepend (MenuItem * item);
      
      void insert (MenuItem * item, int position = -1);

#if 0
      void insert (MenuItem * item,
                   const Accelerator & accel,
                   Slot0<void> * activate_slot,
                   int position = -1);
      void insert (const char * text,
                   const Accelerator & accel,
                   Slot0<void> * activate_slot,
                   int position = -1);
      void insert (const ustring & text,
                   const Accelerator & accel,
                   Slot0<void> * activate_slot,
                   int position = -1);
      void insert_separator (int position = -1);
#endif

      // FIXME this class has some virtual functions and
      // corresponding methods that could be wrapped;
      // for now I won't, they aren't that useful.
      
    protected:
      friend class Private::MenuShellClass;
      
      explicit MenuShell (GtkMenuShell *src, GtkMenuShellClass *orig);
      virtual ~MenuShell () = 0; // abstract
      MenuShell ();
      
    private:
      MenuShell(const MenuShell&);
      MenuShell& operator=(const MenuShell&);
      
    }; // class MenuShell

  }; // namespace Gtk
  
}; // namespace Inti

#endif // _INTI_GTK_MENUSHELL_H_
