// -*- C++ -*-
// Copyright (C) 2000 Red Hat, Inc.
#ifndef _INTI_GTK_RADIOMENUITEM_H_
#define _INTI_GTK_RADIOMENUITEM_H_

/*
  Inti is a C++ development platform based on glib, GTK+, and the
  Standard Template Library. This header file is machine-generated
  by a script; do not edit it directly.

  This file is distributed under the GNU Library General Public License.
*/
/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <inti/gtk/checkmenuitem.h>
#include <inti/gtk/gtkbase.h>
#include <gtk/gtkradiomenuitem.h>

/*$ doc header
  $short FIXME
  $*/

namespace Inti
{  
  namespace Gtk
  {
    namespace Private
    {
      class RadioMenuItemClass;
    };
    
    class RadioMenuItem : public CheckMenuItem
    {
    public:
      /*$ doc class RadioMenuItem
        $short FIXME

        $copy none
        $memory floating
        
        $long

        <para>

        </para>
        
        $*/
        
      GtkRadioMenuItem * gtk_radio_menu_item () const
      {
        return (GtkRadioMenuItem*)g_object ();
      }

      // Keep all Group-related stuff in sync with RadioButton
      class Group
      {
      public:
        RadioMenuItem *get_active ();
        const RadioMenuItem *get_active () const;
      private:
        friend class RadioMenuItem;
        explicit Group (GSList *list);
        GSList * list_;
      };
      
      /*$ doc constructor
        $short Construct a new RadioMenuItem
        $long

        <para>

        </para>
        
        $*/
      RadioMenuItem ();
      RadioMenuItem (const ustring & text);
      RadioMenuItem (Group group);
      RadioMenuItem (Group group, const ustring & text);

      Group group () const;
      void set_group (Group group);
      
    protected:
      friend class Private::RadioMenuItemClass;
      
      explicit RadioMenuItem (GtkRadioMenuItem *src, GtkRadioMenuItemClass *orig);
      virtual ~RadioMenuItem ();
      
    private:
      RadioMenuItem(const RadioMenuItem&);
      RadioMenuItem& operator=(const RadioMenuItem&);
      
    }; // class RadioMenuItem

  }; // namespace Gtk
  
}; // namespace Inti

#endif // _INTI_GTK_RADIOMENUITEM_H_
