// -*- C++ -*-
// Copyright (C) 2000 Red Hat, Inc.
#ifndef _INTI_GTK_SCROLLEDWINDOW_H_
#define _INTI_GTK_SCROLLEDWINDOW_H_

/*
  Inti is a C++ development platform based on glib, GTK+, and the
  Standard Template Library. This header file is machine-generated
  by a script; do not edit it directly.

  This file is distributed under the GNU Library General Public License.
*/
/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <inti/gtk/bin.h>
#include <inti/gtk/gtkbase.h>
#include <gtk/gtkscrolledwindow.h>

/*$ doc header
  $short FIXME
  $*/

namespace Inti
{  
  namespace Gtk
  {
    namespace Private
    {
      class ScrolledWindowClass;
    };

    class Adjustment;
    
    class ScrolledWindow : public Bin
    {
    public:
      /*$ doc class ScrolledWindow
        $short FIXME

        $copy none
        $memory floating
        
        $long

        <para>

        </para>
        
        $*/
        
      GtkScrolledWindow * gtk_scrolled_window () const
      {
        return (GtkScrolledWindow*)g_object ();
      }

      /*$ doc constructor
        $short Construct a new ScrolledWindow
        $long

        <para>

        </para>
        
        $*/
      ScrolledWindow ();

      void set_hadjustment (Inti::Gtk::Adjustment* hadjustment);
      void set_vadjustment (Inti::Gtk::Adjustment* hadjustment);

      Adjustment * hadjustment () const;
      Adjustment * vadjustment () const;

      void set_policy (Gtk::PolicyType hscrollbar_policy, Gtk::PolicyType vscrollbar_policy);
      void set_placement (Gtk::CornerType window_placement);
      void add_with_viewport (Inti::Gtk::Widget* child);
      
    protected:
      friend class Private::ScrolledWindowClass;
      
      explicit ScrolledWindow (GtkScrolledWindow *src, GtkScrolledWindowClass *orig);
      virtual ~ScrolledWindow ();
      
    private:
      ScrolledWindow(const ScrolledWindow&);
      ScrolledWindow& operator=(const ScrolledWindow&);
      
    }; // class ScrolledWindow

  }; // namespace Gtk
  
}; // namespace Inti

#endif // _INTI_GTK_SCROLLEDWINDOW_H_
