// -*- C++ -*-
// Copyright (C) 2000 Red Hat, Inc.
#ifndef _INTI_GTK_VIEWPORT_H_
#define _INTI_GTK_VIEWPORT_H_

/*
  Inti is a C++ development platform based on glib, GTK+, and the
  Standard Template Library. This header file is machine-generated
  by a script; do not edit it directly.

  This file is distributed under the GNU Library General Public License.
*/
/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <inti/gtk/bin.h>
#include <inti/gtk/gtkbase.h>
#include <inti/gtk/scrollable.h>
#include <gtk/gtkviewport.h>

/*$ doc header
  $short FIXME
  $*/

namespace Inti
{  
  namespace Gtk
  {
    namespace Private
    {
      class ViewportClass;
    };
    
    class Viewport : public Bin, public Scrollable
    {
    public:
      /*$ doc class Viewport
        $short FIXME

        $copy none
        $memory floating
        
        $long

        <para>

        </para>
        
        $*/
        
      GtkViewport * gtk_viewport () const
      {
        return (GtkViewport*)g_object ();
      }

      /*$ doc constructor
        $short Construct a new Viewport
        $long

        <para>

        </para>
        
        $*/
      Viewport ();

      Viewport (Adjustment * hadj, Adjustment * vadj);
      
      virtual void set_scroll_adjustments (Adjustment * horizontal,
                                           Adjustment * vertical);
      virtual void set_scroll_hadjustment (Adjustment * hadj);
      virtual void set_scroll_vadjustment (Adjustment * vadj);

      virtual Adjustment * scroll_hadjustment () const;
      virtual Adjustment * scroll_vadjustment () const;

      void set_shadow_type (Gtk::ShadowType type);
      ShadowType shadow_type () const { return (ShadowType) gtk_viewport ()->shadow_type; }
      
    protected:
      friend class Private::ViewportClass;
      
      explicit Viewport (GtkViewport *src, GtkViewportClass *orig);
      virtual ~Viewport ();
      
    private:
      Viewport(const Viewport&);
      Viewport& operator=(const Viewport&);
      
    }; // class Viewport

  }; // namespace Gtk
  
}; // namespace Inti

#endif // _INTI_GTK_VIEWPORT_H_
