// -*- C++ -*-
// Copyright (C) 2000 Red Hat, Inc.
#ifndef _INTI_BASE_IO_H_
#define _INTI_BASE_IO_H_

/*
  Inti is a C++ development platform based on glib, GTK+, and the
  Standard Template Library. This header file is machine-generated
  by a script; do not edit it directly.

  This file is distributed under the GNU Library General Public License.
*/
/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <glib.h>

/*$ doc header
  $short The Inti::IO namespace, containing I/O-related interfaces
  $*/

namespace Inti {

  namespace IO {

    // These correspond the the flags passed to the poll() system
    // call, thus the somewhat odd naming.
    typedef enum {
      IN = G_IO_IN,
      OUT = G_IO_OUT,
      PRI = G_IO_PRI,
      ERR = G_IO_ERR,
      HUP = G_IO_HUP,
      NVAL = G_IO_NVAL
    } ConditionFlags;

    typedef unsigned int ConditionFlagsField;
    
  }; // namespace IO

}; // namespace Inti
#endif // _INTI_BASE_IO_H_
